src/main/java/org/csd322/entities/Special.java
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.csd322.entities;

import java.io.Serializable;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Lob;
import javax.persistence.ManyToMany;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author fred
 */
@Entity
@Table(name = "special")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Special.findAll", query = "SELECT s FROM Special s"),
    @NamedQuery(name = "Special.findById", query = "SELECT s FROM Special s WHERE s.id = :id")})
public class Special implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "id")
    private Integer id;
    @Lob
    @Size(max = 2147483647)
    @Column(name = "description")
    private String description;
    @ManyToMany(mappedBy = "specialList")
    private List<Car> carList;

    public Special() {
    }

    public Special(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @XmlTransient
    public List<Car> getCarList() {
        return carList;
    }

    public void setCarList(List<Car> carList) {
        this.carList = carList;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Special)) {
            return false;
        }
        Special other = (Special) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "org.csd322.entities.Special[ id=" + id + " ]";
    }
    
}

src/main/java/org/csd322/jsfclasses/SpecialController.java
package org.csd322.jsfclasses;

import org.csd322.entities.Special;
import org.csd322.jsfclasses.util.JsfUtil;
import org.csd322.jsfclasses.util.PaginationHelper;
import org.csd322.sessionbeans.SpecialFacade;

import java.io.Serializable;
import java.util.ResourceBundle;
import javax.ejb.EJB;
import javax.inject.Named;
import javax.enterprise.context.SessionScoped;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.FacesConverter;
import javax.faces.model.DataModel;
import javax.faces.model.ListDataModel;
import javax.faces.model.SelectItem;

@Named("specialController")
@SessionScoped
public class SpecialController implements Serializable {

    private Special current;
    private DataModel items = null;
    @EJB
    private org.csd322.sessionbeans.SpecialFacade ejbFacade;
    private PaginationHelper pagination;
    private int selectedItemIndex;

    public SpecialController() {
    }

    public Special getSelected() {
        if (current == null) {
            current = new Special();
            selectedItemIndex = -1;
        }
        return current;
    }

    private SpecialFacade getFacade() {
        return ejbFacade;
    }

    public PaginationHelper getPagination() {
        if (pagination == null) {
            pagination = new PaginationHelper(10) {

                @Override
                public int getItemsCount() {
                    return getFacade().count();
                }

                @Override
                public DataModel createPageDataModel() {
                    return new ListDataModel(getFacade().findRange(new int[]{getPageFirstItem(), getPageFirstItem() + getPageSize()}));
                }
            };
        }
        return pagination;
    }

    public String prepareList() {
        recreateModel();
        return "List";
    }

    public String prepareView() {
        current = (Special) getItems().getRowData();
        selectedItemIndex = pagination.getPageFirstItem() + getItems().getRowIndex();
        return "View";
    }

    public String prepareCreate() {
        current = new Special();
        selectedItemIndex = -1;
        return "Create";
    }

    public String create() {
        try {
            getFacade().create(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle("/Bundle").getString("SpecialCreated"));
            return prepareCreate();
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle("/Bundle").getString("PersistenceErrorOccured"));
            return null;
        }
    }

    public String prepareEdit() {
        current = (Special) getItems().getRowData();
        selectedItemIndex = pagination.getPageFirstItem() + getItems().getRowIndex();
        return "Edit";
    }

    public String update() {
        try {
            getFacade().edit(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle("/Bundle").getString("SpecialUpdated"));
            return "View";
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle("/Bundle").getString("PersistenceErrorOccured"));
            return null;
        }
    }

    public String destroy() {
        current = (Special) getItems().getRowData();
        selectedItemIndex = pagination.getPageFirstItem() + getItems().getRowIndex();
        performDestroy();
        recreatePagination();
        recreateModel();
        return "List";
    }

    public String destroyAndView() {
        performDestroy();
        recreateModel();
        updateCurrentItem();
        if (selectedItemIndex >= 0) {
            return "View";
        } else {
            // all items were removed - go back to list
            recreateModel();
            return "List";
        }
    }

    private void performDestroy() {
        try {
            getFacade().remove(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle("/Bundle").getString("SpecialDeleted"));
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle("/Bundle").getString("PersistenceErrorOccured"));
        }
    }

    private void updateCurrentItem() {
        int count = getFacade().count();
        if (selectedItemIndex >= count) {
            // selected index cannot be bigger than number of items:
            selectedItemIndex = count - 1;
            // go to previous page if last page disappeared:
            if (pagination.getPageFirstItem() >= count) {
                pagination.previousPage();
            }
        }
        if (selectedItemIndex >= 0) {
            current = getFacade().findRange(new int[]{selectedItemIndex, selectedItemIndex + 1}).get(0);
        }
    }

    public DataModel getItems() {
        if (items == null) {
            items = getPagination().createPageDataModel();
        }
        return items;
    }

    private void recreateModel() {
        items = null;
    }

    private void recreatePagination() {
        pagination = null;
    }

    public String next() {
        getPagination().nextPage();
        recreateModel();
        return "List";
    }

    public String previous() {
        getPagination().previousPage();
        recreateModel();
        return "List";
    }

    public SelectItem[] getItemsAvailableSelectMany() {
        return JsfUtil.getSelectItems(ejbFacade.findAll(), false);
    }

    public SelectItem[] getItemsAvailableSelectOne() {
        return JsfUtil.getSelectItems(ejbFacade.findAll(), true);
    }

    public Special getSpecial(java.lang.Integer id) {
        return ejbFacade.find(id);
    }

    @FacesConverter(forClass = Special.class)
    public static class SpecialControllerConverter implements Converter {

        @Override
        public Object getAsObject(FacesContext facesContext, UIComponent component, String value) {
            if (value == null || value.length() == 0) {
                return null;
            }
            SpecialController controller = (SpecialController) facesContext.getApplication().getELResolver().
                    getValue(facesContext.getELContext(), null, "specialController");
            return controller.getSpecial(getKey(value));
        }

        java.lang.Integer getKey(String value) {
            java.lang.Integer key;
            key = Integer.valueOf(value);
            return key;
        }

        String getStringKey(java.lang.Integer value) {
            StringBuilder sb = new StringBuilder();
            sb.append(value);
            return sb.toString();
        }

        @Override
        public String getAsString(FacesContext facesContext, UIComponent component, Object object) {
            if (object == null) {
                return null;
            }
            if (object instanceof Special) {
                Special o = (Special) object;
                return getStringKey(o.getId());
            } else {
                throw new IllegalArgumentException("object " + object + " is of type " + object.getClass().getName() + "; expected type: " + Special.class.getName());
            }
        }

    }

}

src/main/webapp/jsf/special/Create.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:composition template="/template.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.CreateSpecialTitle}"></h:outputText>
        </ui:define>
        <ui:define name="body">
            <h:panelGroup id="messagePanel" layout="block">
                <h:messages errorStyle="color: red" infoStyle="color: green" layout="table"/>
            </h:panelGroup>
            <h:form>
                <h:panelGrid columns="2">
                    <h:outputLabel value="#{bundle.CreateSpecialLabel_id}" for="id" />
                    <h:inputText id="id" value="#{specialController.selected.id}" title="#{bundle.CreateSpecialTitle_id}" required="true" requiredMessage="#{bundle.CreateSpecialRequiredMessage_id}"/>
                    <h:outputLabel value="#{bundle.CreateSpecialLabel_description}" for="description" />
                    <h:inputTextarea rows="4" cols="30" id="description" value="#{specialController.selected.description}" title="#{bundle.CreateSpecialTitle_description}" />
                </h:panelGrid>
                <br />
                <h:commandLink action="#{specialController.create}" value="#{bundle.CreateSpecialSaveLink}" />
                <br />
                <br />
                <h:commandLink action="#{specialController.prepareList}" value="#{bundle.CreateSpecialShowAllLink}" immediate="true"/>
                <br />
                <br />
                <h:link outcome="/index" value="#{bundle.CreateSpecialIndexLink}"/>
            </h:form>
        </ui:define>
    </ui:composition>

</html>

src/main/webapp/jsf/special/Edit.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:composition template="/template.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.EditSpecialTitle}"></h:outputText>
        </ui:define>
        <ui:define name="body">
            <h:panelGroup id="messagePanel" layout="block">
                <h:messages errorStyle="color: red" infoStyle="color: green" layout="table"/>
            </h:panelGroup>
            <h:form>
                <h:panelGrid columns="2">
                    <h:outputLabel value="#{bundle.EditSpecialLabel_id}" for="id" />
                    <h:inputText id="id" value="#{specialController.selected.id}" title="#{bundle.EditSpecialTitle_id}" required="true" requiredMessage="#{bundle.EditSpecialRequiredMessage_id}"/>
                    <h:outputLabel value="#{bundle.EditSpecialLabel_description}" for="description" />
                    <h:inputTextarea rows="4" cols="30" id="description" value="#{specialController.selected.description}" title="#{bundle.EditSpecialTitle_description}" />
                </h:panelGrid>
                <h:commandLink action="#{specialController.update}" value="#{bundle.EditSpecialSaveLink}"/>
                <br />
                <br />
                <h:link outcome="View" value="#{bundle.EditSpecialViewLink}"/>
                <br />
                <h:commandLink action="#{specialController.prepareList}" value="#{bundle.EditSpecialShowAllLink}" immediate="true"/>
                <br />
                <br />
                <h:link outcome="/index" value="#{bundle.EditSpecialIndexLink}" />
            </h:form>
        </ui:define>
    </ui:composition>

</html>

src/main/webapp/jsf/special/List.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:composition template="/template.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.ListSpecialTitle}"></h:outputText>
        </ui:define>
        <ui:define name="body">
            <h:form styleClass="jsfcrud_list_form">
                <h:panelGroup id="messagePanel" layout="block">
                    <h:messages errorStyle="color: red" infoStyle="color: green" layout="table"/>
                </h:panelGroup>
                <h:outputText escape="false" value="#{bundle.ListSpecialEmpty}" rendered="#{specialController.items.rowCount == 0}"/>
                <h:panelGroup rendered="#{specialController.items.rowCount > 0}">
                    <h:outputText value="#{specialController.pagination.pageFirstItem + 1}..#{specialController.pagination.pageLastItem + 1}/#{specialController.pagination.itemsCount}"/>&nbsp;
                    <h:commandLink action="#{specialController.previous}" value="#{bundle.Previous} #{specialController.pagination.pageSize}" rendered="#{specialController.pagination.hasPreviousPage}"/>&nbsp;
                    <h:commandLink action="#{specialController.next}" value="#{bundle.Next} #{specialController.pagination.pageSize}" rendered="#{specialController.pagination.hasNextPage}"/>&nbsp;
                    <h:dataTable value="#{specialController.items}" var="item" border="0" cellpadding="2" cellspacing="0" rowClasses="jsfcrud_odd_row,jsfcrud_even_row" rules="all" style="border:solid 1px">
                        <h:column>
                            <f:facet name="header">
                                <h:outputText value="#{bundle.ListSpecialTitle_id}"/>
                            </f:facet>
                            <h:outputText value="#{item.id}"/>
                        </h:column>
                        <h:column>
                            <f:facet name="header">
                                <h:outputText value="#{bundle.ListSpecialTitle_description}"/>
                            </f:facet>
                            <h:outputText value="#{item.description}"/>
                        </h:column>
                        <h:column>
                            <f:facet name="header">
                                <h:outputText value="&nbsp;"/>
                            </f:facet>
                            <h:commandLink action="#{specialController.prepareView}" value="#{bundle.ListSpecialViewLink}"/>
                            <h:outputText value=" "/>
                            <h:commandLink action="#{specialController.prepareEdit}" value="#{bundle.ListSpecialEditLink}"/>
                            <h:outputText value=" "/>
                            <h:commandLink action="#{specialController.destroy}" value="#{bundle.ListSpecialDestroyLink}"/>
                        </h:column>
                    </h:dataTable>
                </h:panelGroup>
                <br />
                <h:commandLink action="#{specialController.prepareCreate}" value="#{bundle.ListSpecialCreateLink}"/>
                <br />
                <br />
                <h:link outcome="/index" value="#{bundle.ListSpecialIndexLink}"/>
            </h:form>
        </ui:define>
    </ui:composition>

</html>

src/main/webapp/jsf/special/View.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:composition template="/template.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.ViewSpecialTitle}"></h:outputText>
        </ui:define>
        <ui:define name="body">
            <h:panelGroup id="messagePanel" layout="block">
                <h:messages errorStyle="color: red" infoStyle="color: green" layout="table"/>
            </h:panelGroup>
            <h:form>
                <h:panelGrid columns="2">
                    <h:outputText value="#{bundle.ViewSpecialLabel_id}"/>
                    <h:outputText value="#{specialController.selected.id}" title="#{bundle.ViewSpecialTitle_id}"/>
                    <h:outputText value="#{bundle.ViewSpecialLabel_description}"/>
                    <h:outputText value="#{specialController.selected.description}" title="#{bundle.ViewSpecialTitle_description}"/>
                </h:panelGrid>
                <br />
                <h:commandLink action="#{specialController.destroyAndView}" value="#{bundle.ViewSpecialDestroyLink}"/>
                <br />
                <br />
                <h:link outcome="Edit" value="#{bundle.ViewSpecialEditLink}"/>
                <br />
                <h:commandLink action="#{specialController.prepareCreate}" value="#{bundle.ViewSpecialCreateLink}" />
                <br />
                <h:commandLink action="#{specialController.prepareList}" value="#{bundle.ViewSpecialShowAllLink}"/>
                <br />
                <br />
                <h:link outcome="/index" value="#{bundle.ViewSpecialIndexLink}"/>

            </h:form>
        </ui:define>
    </ui:composition>

</html>